-- by xyzspain  creacion de attachJoint

Packer = {};

function Packer.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Cultivator, specializations);
end;
function Packer:load(xmlFile)
            print("'lua loaded '" );	
	self.rollerNodeLeft1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.roller#index1"));
	
	self.rollerNodeRight1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.roller#index2"));
	
	self.rollerRotationScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.roller#rotationScale"), 1);
   local translationNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.translation1#index"));
    if translationNode1 ~= nil then
        self.translation1 = {};
        self.translation1.node = translationNode1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation1#minTrans"));
        self.translation1.minTrans = {};
        self.translation1.minTrans[1] = Utils.getNoNil(x, 0);
        self.translation1.minTrans[2] = Utils.getNoNil(y, 0);
        self.translation1.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation1#maxTrans"));
        self.translation1.maxTrans = {};
        self.translation1.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translation1.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translation1.maxTrans[3] = Utils.getNoNil(z, 0);
		      self.translation1.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation1#transTime"), 2)*1000;
      
    end;
	local translationNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.translation2#index"));
    if translationNode2 ~= nil then
        self.translation2 = {};
        self.translation2.node = translationNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation2#minTrans"));
        self.translation2.minTrans = {};
        self.translation2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translation2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translation2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation2#maxTrans"));
        self.translation2.maxTrans = {};
        self.translation2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translation2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translation2.maxTrans[3] = Utils.getNoNil(z, 0);

	

        self.translation2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation2#transTime"), 2)*1000;
      
    end;
	local translationNode3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.translation3#index"));
    if translationNode3 ~= nil then
        self.translation3 = {};
        self.translation3.node = translationNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation3#minTrans"));
        self.translation3.minTrans = {};
        self.translation3.minTrans[1] = Utils.getNoNil(x, 0);
        self.translation3.minTrans[2] = Utils.getNoNil(y, 0);
        self.translation3.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation3#maxTrans"));
        self.translation3.maxTrans = {};
        self.translation3.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translation3.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translation3.maxTrans[3] = Utils.getNoNil(z, 0);

	

        self.translation3.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation3#transTime"), 2)*1000;
      
    end;
	local translationNode4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.translation4#index"));
    if translationNode4 ~= nil then
        self.translation4 = {};
        self.translation4.node = translationNode4;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation4#minTrans"));
        self.translation4.minTrans = {};
        self.translation4.minTrans[1] = Utils.getNoNil(x, 0);
        self.translation4.minTrans[2] = Utils.getNoNil(y, 0);
        self.translation4.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation4#maxTrans"));
        self.translation4.maxTrans = {};
        self.translation4.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translation4.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translation4.maxTrans[3] = Utils.getNoNil(z, 0);

	

        self.translation4.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation4#transTime"), 4)*1000;
      
    end;
  local attacherJoint1 = {};
    attacherJoint1.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.attacherJoint1#index"));
    if attacherJoint1.node ~= nil then
        attacherJoint1.topReferenceNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.attacherJoint1#topReferenceNode"));
        attacherJoint1.rootNode = Utils.getNoNil(Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.attacherJoint1#rootNode")), self.components[1].node);
        attacherJoint1.fixedRotation = Utils.getNoNil(getXMLBool(xmlFile, "vehicle.attacherJoint1#fixedRotation"), false);
        local jointTypeStr = getXMLString(xmlFile, "vehicle.attacherJoint1#jointType")
        local jointType;
        if jointTypeStr ~= nil then
            jointType = Vehicle.jointTypeNameToInt[jointTypeStr];
            if jointType == nil then
                print("Warning: invalid jointType " .. jointTypeStr);
            end;
        else
            print("Warning: missing jointType");
        end;
    	attacherJoint1.jointType = jointType;
    	self.attacherJoint1 = attacherJoint1;

    end;

    local attacherJoint2 = {};
    attacherJoint2.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.attacherJoint2#index"));
    if attacherJoint2.node ~= nil then
        attacherJoint2.topReferenceNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.attacherJoint2#topReferenceNode"));
        attacherJoint2.rootNode = Utils.getNoNil(Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.attacherJoint2#rootNode")), self.components[1].node);
        attacherJoint2.fixedRotation = Utils.getNoNil(getXMLBool(xmlFile, "vehicle.attacherJoint2#fixedRotation"), false);
        local jointTypeStr = getXMLString(xmlFile, "vehicle.attacherJoint2#jointType")
        local jointType;
        if jointTypeStr ~= nil then
            jointType = Vehicle.jointTypeNameToInt[jointTypeStr];
            if jointType == nil then
                print("Warning: invalid jointType " .. jointTypeStr);
            end;
        else
            print("Warning: missing jointType");
        end;
    	attacherJoint2.jointType = jointType;
    	self.attacherJoint2 = attacherJoint2;
    end;
 local attacherJoint3 = {};
    attacherJoint3.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.attacherJoint3#index"));
    if attacherJoint3.node ~= nil then
        attacherJoint3.topReferenceNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.attacherJoint3#topReferenceNode"));
        attacherJoint3.rootNode = Utils.getNoNil(Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.attacherJoint3#rootNode")), self.components[1].node);
        attacherJoint3.fixedRotation = Utils.getNoNil(getXMLBool(xmlFile, "vehicle.attacherJoint3#fixedRotation"), false);
        local jointTypeStr = getXMLString(xmlFile, "vehicle.attacherJoint3#jointType")
        local jointType;
        if jointTypeStr ~= nil then
            jointType = Vehicle.jointTypeNameToInt[jointTypeStr];
            if jointType == nil then
                print("Warning: invalid jointType " .. jointTypeStr);
            end;
        else
            print("Warning: missing jointType");
        end;
    	attacherJoint3.jointType = jointType;
    	self.attacherJoint3 = attacherJoint3;
    end;
  
	
	
	-- local workSound = getXMLString(xmlFile, "vehicle.workSound#file");
    -- if workSound ~= nil and workSound ~= "" then
        -- workSound = Utils.getFilename(workSound, self.baseDirectory); 
        -- self.workSound = createSample("workSound");
        -- self.workSoundEnabled = false;
        -- loadSample(self.workSound, workSound, false);
        -- self.workSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#pitchOffset"), 1);
        -- self.workSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#volume"), 1);
    -- end;

	  self.attacherJoint = self.attacherJoint1;
	self.translation1max = true ;
self.translation2max = true ;
	self.translation3max = false ;
	self.translation4max = false ;
	
	 self.turnOn = false;
	
	
   
   
	 self.lastSoundSpeed = 0;
    self.rotationSpeed = 1;
	
	 
end;

function Packer:delete()
 -- if self.workSound ~= nil then
        -- delete(self.workSound);
    -- end;

end;


function Packer:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Packer:keyEvent(unicode, sym, modifier, isDown)
-- ciclo brazos
	  if isDown and sym == Input.KEY_j then
	if self.attacherJoint == self.attacherJoint2 then
		self.attacherJoint = self.attacherJoint3;
		-- self.translation1max = true ;
		self.translation2max = false;
		self.translation3max = true ;
		self.translation4max = true ;
		 self.turnOn = true;
	else
		self.attacherJoint = self.attacherJoint2;
		self.translation1max = false ;
		-- self.translation2max = true ;
		self.translation3max = true ;
		self.translation4max = true ;
		 self.turnOn = true;
		end;
		

		self.attacherVehicle:detachImplementByObject(self);
	end;
--para desconectar el ciclo  brazos
  if isDown and sym == Input.KEY_k then
	if self.attacherJoint == self.attacherJoint1 then
		self.attacherJoint = self.attacherJoint2;
		 self.turnOn = true;
	else
		self.attacherJoint = self.attacherJoint1;
		self.turnOn = false;
	end;	
	self.attacherVehicle:detachImplementByObject(self);
	end;	
	--para tramsporte
	if isDown and sym == Input.KEY_m  then
		self.translation1max = true;
		self.translation2max =  true;
		self.translation3max =  false;
		self.translation4max =  false;
	end;
	
end;


function Packer:update(dt)
	--mover colisiones en el enganche
	if self.attacherVehicle then
		if self.attacherJoint == self.attacherJoint2 then
		self.translation1max = true;
		self.translation2max = false ;
		end;
		if self.attacherJoint == self.attacherJoint3 then
		self.translation1max = false ;
		self.translation2max = true ;
		end;
	end;
	-- activacion de roller y cuttingAreas
	if self.turnOn and self:getIsActive() then
		
		
			if self.rollerNodeLeft1 ~= nil then
				rotate(self.rollerNodeLeft1, self.rollerRotationScale * self.attacherVehicle.lastSpeed * self.attacherVehicle.movingDirection, 0, 0);
			end;
			
			
			if self.rollerNodeRight1 ~= nil then
				rotate(self.rollerNodeRight1, self.rollerRotationScale * self.attacherVehicle.lastSpeed * self.attacherVehicle.movingDirection, 0, 0);
			end;

	
			
			if table.getn(self.cuttingAreas) > 0 then
				local x,y,z = getWorldTranslation(self.cuttingAreas[1].start);
				local x1,y1,z1 = getWorldTranslation(self.cuttingAreas[1].width);
				local x2,y2,z2 = getWorldTranslation(self.cuttingAreas[1].height);
				Utils.updateCultivatorArea(x, z, x1, z1, x2, z2);
			end;
	
	  end;
	  
	  

		--rotaciones y translaciones
	
	if self.translation1max ~= nil then 
		local x, y, z = getTranslation(self.translation1.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translation1.maxTrans, self.translation1.minTrans, 3, self.translation1.transTime, dt, not self.translation1max); 
		setTranslation(self.translation1.node, unpack(newTrans)); 
	end;
	
	if self.translation2max ~= nil  then 
		local x, y, z = getTranslation(self.translation2.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translation2.maxTrans, self.translation2.minTrans, 3, self.translation2.transTime, dt, not self.translation2max); 
		setTranslation(self.translation2.node, unpack(newTrans)); 
	end;
	if self.translation3max ~= nil  then 
		local x, y, z = getTranslation(self.translation3.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translation3.maxTrans, self.translation3.minTrans, 3, self.translation3.transTime, dt, not self.translation3max); 
		setTranslation(self.translation3.node, unpack(newTrans)); 
	end;
	if self.translation4max ~= nil  then 
		local x, y, z = getTranslation(self.translation4.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translation4.maxTrans, self.translation4.minTrans, 3, self.translation4.transTime, dt, not self.translation4max); 
		setTranslation(self.translation4.node, unpack(newTrans)); 
	end;
	--fijar componentes que trabajan por links
local joint = self.componentJoints[3];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
	local joint = self.componentJoints[4];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
end;

function Packer:draw()
	
	
	
	
	
end;


function Packer:onLeave()
    -- if self.deactivateOnLeave then
        -- Packer.onDeactivate(self);
    -- else
        -- Packer.onDeactivateSounds(self);
    -- end;
end;

-- function Packer:onDeactivate()
    
         -- Packer.onDeactivateSounds(self);
-- end;
-- function Packer:onDeactivateSounds()
    -- if self.workSoundEnabled then
        -- stopSample(self.workSound);
        -- self.workSoundEnabled = false;
    -- end;
-- end;




